/*
 ͻ
  SPI2.C      (c) GRUPO J&J. Agosto 1997.                                  
 ͹
                                                                           
  Ejemplo de prueba de la libreria CTCLIENT.C                              
                                                                           
  Programa para leer y recibir dator por el SPI. Para hacer las pruebas se 
  utiliza la PCT595 que dispone de 8 led y 8 switches de entrada. En este  
  ejemplo se imprime en pantalla el estado de los swtiches y se envan a   
  los leds.                                                                
                                                                           
 ͼ
*/
typedef unsigned short int byte;

#include "stdio.h"
#include "dos.h"
#include "conio.h"

/* Librerias utilizadas del Grupo J&J */

#include "serie.h"
#include "ctclient.h"
#include "bootstrp.h"
#include "R6811pc.h"
void accion_rxcar()
{
}

void accion_break()
{
}

byte puertof1(byte d)
/* Enviar dato por el puerto f1 */
{
  byte temp;

  store(d,SPDR);
  load(&temp,SPSR);
  load(&temp,SPDR);
  store(0xFF,PORTD);
  store(0x00,PORTD);

  return temp;
}

void puertof2(byte *d)
/* Leer un dato del puerto f2 */
{
  byte temp;

  store(0x00,PORTD);
  store(0xFF,PORTD);

  store(0,SPDR);
  load(&temp,SPSR);
  load(d,SPDR);
}



void carga()
{
  static byte n=0;
  static byte i=0;

  if (n==16 || i==255) {
    n=0;
    printf ("");
  }

  i++;
  n++;
}

unsigned short int programint[256]={
0x20,0x05,0x00,0x00,0x00,0x00,0x00,0xCE,0x10,0x00,0x18,0xCE,0xFF,0xFF,0x18,
0x09,0x18,0x8C,0x00,0x00,0x26,0xF8,0x86,0x30,0xA7,0x2B,0xCE,0x10,0x00,0x8D,
0x66,0x97,0x06,0x81,0x44,0x27,0x13,0x81,0x43,0x27,0x54,0x81,0x41,0x27,0x17,
0x81,0x42,0x27,0x0E,0x81,0x45,0x27,0x6A,0x7E,0x00,0x1A,0x86,0x4A,0x8D,0x50,
0x7E,0x00,0x1A,0x7C,0x00,0x06,0x20,0x03,0x7F,0x00,0x06,0x8D,0x4A,0x18,0xDF,
0x02,0x8D,0x45,0x18,0xDF,0x04,0x18,0x8C,0x00,0x00,0x27,0x23,0x18,0xDE,0x02,
0x96,0x06,0x4D,0x26,0x07,0x18,0xA6,0x00,0x8D,0x28,0x20,0x05,0x8D,0x1D,0x18,
0xA7,0x00,0x18,0x08,0x18,0xDF,0x02,0x18,0xDE,0x04,0x18,0x09,0x18,0xDF,0x04,
0x20,0xD7,0x7E,0x00,0x1A,0x8D,0x14,0x18,0xDF,0x02,0x18,0x6E,0x00,0x1F,0x2E,
0x10,0xFC,0xA6,0x2F,0x39,0x1F,0x2E,0x80,0xFC,0xA7,0x2F,0x39,0x36,0x37,0x8D,
0xEE,0x16,0x8D,0xEB,0x18,0x8F,0x33,0x32,0x39,0x8D,0xF2,0x18,0xDF,0x02,0x8D,
0xED,0x18,0xDF,0x04,0x18,0x8C,0x00,0x00,0x27,0x34,0x18,0xDE,0x02,0xC6,0x16,
0xF7,0x10,0x3B,0x18,0xE7,0x00,0xC6,0x17,0xF7,0x10,0x3B,0x8D,0x28,0xC6,0x02,
0xF7,0x10,0x3B,0x8D,0xBD,0x8D,0xC2,0x18,0xA7,0x00,0xC6,0x03,0xF7,0x10,0x3B,
0x8D,0x15,0x18,0x08,0x18,0xDF,0x02,0x18,0xDE,0x04,0x18,0x09,0x18,0xDF,0x04,
0x20,0xC6,0x7F,0x10,0x3B,0x7E,0x00,0x1A,0x18,0x3C,0x18,0xCE,0x0D,0x10,0x18,
0x09,0x18,0x8C,0x00,0x00,0x26,0xF8,0x18,0x38,0x39,0x00,0x00,0x00,0x00,0x00,
0x00,};


main()
{
  byte valor;
  char c;
  S19 fs19;
  char *caderror;
  byte i;

  clrscr();

  abrir_puerto_serie(2);  /* Abrir sesion con puerto serie COM2 */
  baudios(9600);

  check_conexion();
  if (!hay_conexion()) {
    printf ("\nNO HAY CONEXION\n");
    if (abrir_s19("ctserver.s19",&fs19,1)==0) {
      caderror=(char *)geterrors19();
      printf ("Error: %s\n",caderror);
      return 0;
    }
    printf ("\n");

    printf ("0%     50%   100%\n");
    printf ("\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b");

    resetct6811();
    if (cargar_ramint(programint,carga)==0) {
      printf ("\nError: %s",getloaderror());
      cerrar_puerto_serie();
      return 0;
    };
    printf (" OK!!\n");


    delay(1000);
    baudios(9600);
  }

  check_conexion();
  if (!hay_conexion()) {
    printf ("Conexion no establecida\n");
    cerrar_puerto_serie();
    return 0;
  }
  printf ("CONEXION ESTABLECIDA\n");

  /* Configurar SPI */

  clrscr();

  store(0x38,DDRD);
  store(0x5C,SPCR);
  store(0xFF,PORTD);

  do {
    puertof2(&i);
    gotoxy(5,5);
    printf ("%3u",i&0xFF);
    puertof1(i);
  } while (!kbhit() && hay_conexion());

  if (!hay_conexion()) printf ("\nconexion perdida");
  getch();

  cerrar_puerto_serie();
  return 0;
}